| API Docs for SAX and DOM |

Main Page | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Class Members | File Members | Related Pages

# DOMXPathResult Class Reference

The `DOMXPathResult` interface represents the result of the evaluation of an XPath 1.0 expression within the context of a particular node. More...

List of all members.

## Public Types

Public Contants
enum | resultType { ANY_TYPE = 0, NUMBER_TYPE = 1, STRING_TYPE = 2, BOOLEAN_TYPE = 3, UNORDERED_NODE_ITERATOR_TYPE = 4, ORDERED_NODE_ITERATOR_TYPE = 5, UNORDERED_NODE_SNAPSHOT_TYPE = 6, ORDERED_NODE_SNAPSHOT_TYPE = 7, ANY_UNORDERED_NODE_TYPE = 8, FIRST_ORDERED_NODE_TYPE = 9 }

## Public Member Functions

Destructor
virtual | ~DOMXPathResult ()
| Destructor.
Functions introduced in DOM Level 3
virtual bool | getBooleanValue () const =0
| Returns the boolean value of this result.
virtual bool | getInvalidIteratorState () const =0
| Returns the state of the iterator.
virtual double | getNumberValue () const =0
| Returns the number value of this result.
virtual short | getResultType () const =0
| Returns the result type of this result.
virtual DOMNode * | getSingleNodeValue () const =0
| Returns the single node value of this result.
virtual unsigned long | getSnapshotLength () const =0
| Returns the snapshot length.
virtual const XMLCh * | getStringValue () const =0
| Returns the string value of this result.
virtual DOMNode * | iterateNext () const =0
| Iterates and returns the next node from the node set or nullif there are no more nodes.
virtual DOMNode * | snapshotItem (unsigned long index) const =0
| Returns the indexth item in the snapshot collection.

## Protected Member Functions

Hidden constructors
| DOMXPathResult ()

## Detailed Description

The `DOMXPathResult` interface represents the result of the evaluation of an XPath 1.0 expression within the context of a particular node.

Since evaluation of an XPath expression can result in various result types, this object makes it possible to discover and manipulate the type and value of the result.

Since:
  DOM Level 3

## Member Enumeration Documentation

enum DOMXPathResult::resultType

ANY_TYPE
This code does not represent a specific type. An evaluation of an XPath expression will never produce this type. If this type is requested, then the evaluation returns whatever type naturally results from evaluation of the expression. If the natural result is a node set when ANY_TYPE was requested, then UNORDERED_NODE_ITERATOR_TYPE is always the resulting type. Any other representation of a node set must be explicitly requested.

ANY_UNORDERED_NODE_TYPE
The result is a node set as defined by [XPath 1.0] and will be accessed as a single node, which may be nullif the node set is empty. Document modification does not invalidate the node, but may mean that the result node no longer corresponds to the current document. This is a convenience that permits optimization since the implementation can stop once any node in the resulting set has been found. If there is more than one node in the actual result, the single node returned might not be the first in document order.

BOOLEAN_TYPE
The result is a boolean as defined by [XPath 1.0]. Document modification does not invalidate the boolean, but may mean that reevaluation would not yield the same boolean.

FIRST_ORDERED_NODE_TYPE
The result is a node set as defined by [XPath 1.0] and will be accessed as a single node, which may be null if the node set is empty. Document modification does not invalidate the node, but may mean that the result node no longer corresponds to the current document. This is a convenience that permits optimization since the implementation can stop once the first node in document order of the resulting set has been found. If there are more than one node in the actual result, the single node returned will be the first in document order.

NUMBER_TYPE
The result is a number as defined by [XPath 1.0]. Document modification does not invalidate the number, but may mean that reevaluation would not yield the same number.

ORDERED_NODE_ITERATOR_TYPE
The result is a node set as defined by [XPath 1.0] that will be accessed iteratively, which will produce document-ordered nodes. Document modification invalidates the iteration.

ORDERED_NODE_SNAPSHOT_TYPE
The result is a node set as defined by [XPath 1.0] that will be accessed as a snapshot list of nodes that will be in original document order. Document modification does not invalidate the snapshot but may mean that reevaluation would not yield the same snapshot and nodes in the snapshot may have been altered, moved, or removed from the document.

STRING_TYPE
The result is a string as defined by [XPath 1.0]. Document modification does not invalidate the string, but may mean that the string no longer corresponds to the current document.

UNORDERED_NODE_ITERATOR_TYPE
The result is a node set as defined by [XPath 1.0] that will be accessed iteratively, which may not produce nodes in a particular order. Document modification invalidates the iteration. This is the default type returned if the result is a node set and ANY_TYPE is requested.

UNORDERED_NODE_SNAPSHOT_TYPE
The result is a node set as defined by [XPath 1.0] that will be accessed as a snapshot list of nodes that may not be in a particular order. Document modification does not invalidate the snapshot but may mean that reevaluation would not yield the same snapshot and nodes in the snapshot may have been altered, moved, or removed from the document.

Enumeration values:

  ANY_TYPE |
  NUMBER_TYPE |
  STRING_TYPE |
  BOOLEAN_TYPE |
  UNORDERED_NODE_ITERATOR_TYPE |
  ORDERED_NODE_ITERATOR_TYPE |
  UNORDERED_NODE_SNAPSHOT_TYPE |
  ORDERED_NODE_SNAPSHOT_TYPE |
  ANY_UNORDERED_NODE_TYPE |
  FIRST_ORDERED_NODE_TYPE |

## Constructor & Destructor Documentation

DOMXPathResult::DOMXPathResult | ( |  | ) | `[protected]`

virtual DOMXPathResult::~DOMXPathResult | ( |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

virtual bool DOMXPathResult::getBooleanValue | ( |  | ) | const`[pure virtual]`

Returns the boolean value of this result.

Returns:
  booleanValue of type boolean, readonly The value of this boolean result.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not BOOLEAN_TYPE.

virtual bool DOMXPathResult::getInvalidIteratorState | ( |  | ) | const`[pure virtual]`

Returns the state of the iterator.

Returns:
  invalidIteratorState Signifies that the iterator has become invalid. True if resultType is UNORDERED_NODE_ITERATOR_TYPE or ORDERED_NODE_ITERATOR_TYPE and the document has been modified since this result was returned.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not NUMBER_TYPE.

virtual double DOMXPathResult::getNumberValue | ( |  | ) | const`[pure virtual]`

Returns the number value of this result.

Returns:
  numberValue The value of this number result. If the native double type of the DOM binding does not directly support the exact IEEE 754 result of the XPath expression, then it is up to the definition of the binding to specify how the XPath number is converted to the native binding number.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not NUMBER_TYPE.

virtual short DOMXPathResult::getResultType | ( |  | ) | const`[pure virtual]`

Returns the result type of this result.

Returns:
  resultType A code representing the type of this result, as defined by the type constants.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not ANY_UNORDERED_NODE_TYPE or FIRST_ORDERED_NODE_TYPE.

virtual DOMNode* DOMXPathResult::getSingleNodeValue | ( |  | ) | const`[pure virtual]`

Returns the single node value of this result.

Returns:
  singleNodeValue The value of this single node result, which may be null.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not ANY_UNORDERED_NODE_TYPE or FIRST_ORDERED_NODE_TYPE.

virtual unsigned long DOMXPathResult::getSnapshotLength | ( |  | ) | const`[pure virtual]`

Returns the snapshot length.

Returns:
  snapshotLength The number of nodes in the result snapshot. Valid values for snapshotItem indices are 0 to snapshotLength-1 inclusive.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not UNORDERED_NODE_SNAPSHOT_TYPE or ORDERED_NODE_SNAPSHOT_TYPE.

virtual const XMLCh* DOMXPathResult::getStringValue | ( |  | ) | const`[pure virtual]`

Returns the string value of this result.

Returns:
  stringValue The value of this string result.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not STRING_TYPE.

virtual DOMNode* DOMXPathResult::iterateNext | ( |  | ) | const`[pure virtual]`

Iterates and returns the next node from the node set or nullif there are no more nodes.

Returns:
  the next node.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not UNORDERED_NODE_ITERATOR_TYPE or ORDERED_NODE_ITERATOR_TYPE.
  | DOMException | INVALID_STATE_ERR: The document has been mutated since the result was returned.

virtual DOMNode* DOMXPathResult::snapshotItem | ( | unsigned long | index | ) | const`[pure virtual]`

Returns the indexth item in the snapshot collection.

If index is greater than or equal to the number of nodes in the list, this method returns null. Unlike the iterator result, the snapshot does not become invalid, but may not correspond to the current document if it is mutated.

Parameters:

  | index | of type unsigned long - Index into the snapshot collection.

Returns:
  The node at the indexth position in the NodeList, or null if that is not a valid index.

Exceptions:

  | XPathException | TYPE_ERR: raised if resultType is not UNORDERED_NODE_SNAPSHOT_TYPE or ORDERED_NODE_SNAPSHOT_TYPE.

The documentation for this class was generated from the following file:

- DOMXPathResult.hpp

Copyright © 1994-2004 The Apache Software Foundation. All Rights Reserved.